package com.fs.system.service;

import java.math.BigDecimal;
import java.time.LocalDate;
import java.util.List;
import com.baomidou.mybatisplus.extension.service.IService;
import com.fs.common.core.domain.model.LoginUser;
import com.fs.system.domain.SysDeptConfig;

/**
 * 部门配置Service接口
 * 
 * @author fs
 * @date 2025-09-22
 */
public interface ISysDeptConfigService extends IService<SysDeptConfig>{
    /**
     * 查询部门配置
     * 
     * @param id 部门配置主键
     * @return 部门配置
     */
    SysDeptConfig selectSysDeptConfigById(Long id);

    /**
     * 查询部门配置列表
     * 
     * @param sysDeptConfig 部门配置
     * @return 部门配置集合
     */
    List<SysDeptConfig> selectSysDeptConfigList(SysDeptConfig sysDeptConfig);

    /**
     * 新增部门配置
     * 
     * @param sysDeptConfig 部门配置
     * @return 结果
     */
    int insertSysDeptConfig(SysDeptConfig sysDeptConfig);

    /**
     * 修改部门配置
     * 
     * @param sysDeptConfig 部门配置
     * @return 结果
     */
    int updateSysDeptConfig(SysDeptConfig sysDeptConfig);

    /**
     * 批量删除部门配置
     * 
     * @param ids 需要删除的部门配置主键集合
     * @return 结果
     */
    int deleteSysDeptConfigByIds(Long[] ids);

    /**
     * 删除部门配置信息
     * 
     * @param id 部门配置主键
     * @return 结果
     */
    int deleteSysDeptConfigById(Long id);

    void updatePadNum(Long deptId, Integer num, LoginUser loginUser, LocalDate endTime);

    void addRedMoney(Long deptId, BigDecimal num, LoginUser loginUser);

    void addFlowNum(Long deptId, BigDecimal money, LoginUser loginUser);

    SysDeptConfig getDeptConfig(Long deptId, LoginUser loginUser);
    SysDeptConfig getDeptConfig(Long deptId);
}
